function wt = swt3(X,varargin)
%AmyLin 2011.11$
nbIn = nargin;
msg = nargchk(2,4,nbIn); %#ok<NCHK>
if ~isempty(msg)
    error('Wavelet:FunctionInput:NbArg',msg)
end
LoD = cell(1,3); HiD = cell(1,3); LoR = cell(1,3); HiR = cell(1,3);
argStatus = true;
nextARG = 2;
if ischar(varargin{1})
    [LD,HD,LR,HR] = wfilters(varargin{1});
    for k = 1:3
        LoD{k} = LD; HiD{k} = HD; LoR{k} = LR; HiR{k} = HR;
    end
    elseif isstruct(varargin{1})
    if isfield(varargin{1},'w1') && isfield(varargin{1},'w2') && ...
            isfield(varargin{1},'w3')
        for k = 1:3
            [LoD{k},HiD{k},LoR{k},HiR{k}] = ...
                wfilters(varargin{1}.(['w' int2str(k)]));
        end
    elseif isfield(varargin{1},'LoD') && isfield(varargin{1},'HiD') && ...
           isfield(varargin{1},'LoR') && isfield(varargin{1},'HiR')
        for k = 1:3
            LoD{k} = varargin{1}.LoD{k}; HiD{k} = varargin{1}.HiD{k};
            LoR{k} = varargin{1}.LoR{k}; HiR{k} = varargin{1}.HiR{k};
        end
    else
        argStatus = false;
    end
    
elseif iscell(varargin{1})
    if ischar(varargin{1}{1})
        for k = 1:3
            [LoD{k},HiD{k},LoR{k},HiR{k}] = wfilters(varargin{1}{k});
        end
    elseif iscell(varargin{1})
        Sarg = size(varargin{1});
        if isequal(Sarg,[1 4])
            if ~iscell(varargin{1}{1})
                LoD(1:end) = varargin{1}(1); HiD(1:end) = varargin{1}(2);
                LoR(1:end) = varargin{1}(3); HiR(1:end) = varargin{1}(4);
            else
                LoD = varargin{1}{1}; HiD = varargin{1}{2};
                LoR = varargin{1}{3}; HiR = varargin{1}{4};
            end
        elseif isequal(Sarg,[3 4])
            LoD = varargin{1}(:,1)'; HiD = varargin{1}(:,2)';
            LoR = varargin{1}(:,3)'; HiR = varargin{1}(:,4)';
        else
            argStatus = false;
        end
    end
else
    argStatus = false;
end
if ~argStatus
    error('Wavelet:FunctionInput:ArgVal','Invalid argument value!');
end
sX = size(X);

% Check arguments for Extension.
%dwtEXTM = 'sym'; 
dwtEXTM = 'per'; 

for k = nextARG:2:nbIn-1
    switch varargin{k}
      case 'mode'  , dwtEXTM = varargin{k+1};
    end
end


X = double(X);
dec = cell(2,2,2);
permVect = [];
[a_Lo,d_Hi] = swt1D(X,LoD{1},HiD{1},permVect,dwtEXTM);
permVect = [2,1,3]; 
[aa_Lo_Lo,da_Lo_Hi] = swt1D(a_Lo,LoD{2},HiD{2},permVect,dwtEXTM);
[ad_Hi_Lo,dd_Hi_Hi] = swt1D(d_Hi,LoD{2},HiD{2},permVect,dwtEXTM);
permVect = [1,3,2];
[dec{1,1,1},dec{1,1,2}] = swt1D(aa_Lo_Lo,LoD{3},HiD{3},permVect,dwtEXTM);
[dec{2,1,1},dec{2,1,2}] = swt1D(da_Lo_Hi,LoD{3},HiD{3},permVect,dwtEXTM);
[dec{1,2,1},dec{1,2,2}] = swt1D(ad_Hi_Lo,LoD{3},HiD{3},permVect,dwtEXTM);
[dec{2,2,1},dec{2,2,2}] = swt1D(dd_Hi_Hi,LoD{3},HiD{3},permVect,dwtEXTM);
wt.sizeINI = sX;
wt.filters.LoD = LoD;
wt.filters.HiD = HiD;
wt.filters.LoR = LoR;
wt.filters.HiR = HiR;
wt.mode = dwtEXTM;
wt.dec = dec;

%-----------------------------------------------------------------------%
function [L,H] = swt1D(X,Lo,Hi,perm,dwtEXTM)

if ~isempty(perm) , X = permute(X,perm); end
sX = size(X); %size of X
if length(sX)<3 , sX(3) = 1; end

lf = length(Lo);  %length of filter
lx = sX(2);  %length of signal y-dim
lc = lx+lf-1;  %length of deompose and EXTract coefficient

%%
if lx<lf+1
    nbAdd = lf-lx+1; %7=8-2+1
   switch dwtEXTM
        case {'sym','symh','symw','asym','asymh','asymw','ppd'}
            Add = zeros(sX(1),nbAdd,sX(3));
            X = [Add , X , Add];
    end
end

 switch dwtEXTM
%         
% %     case {'sym','symh'}    % Symmetric extension (half-point).
% %         X = [X(:,lf-1:-1:1,:) , X , X(:,end:-1:end-lf+1,:)];
% %         
% 
%Extension. Cicular Shift %amy change 2011.11.10
    case 'per'             % Periodized extension (2).
        if rem(lx,2) , X = [X , X(:,end,:)]; lx = lx + 1; end
        %I = [lx-lf+1:lx , 1:lx , 1:lf]; %original 144
        I = [lx-lf/2+1:lx , 1:lx , 1:lf/2]; %amy change 136
        if lx<lf
            I = mod(I,lx);
            I(I==0) = lx;
        end
        X = X(:,I,:);
 end
%L = convn(X,Lo); 
%H = convn(X,Hi);

%%%%%%%%%%%%%%
%amy modify 
%%%%%%%%%%%%%%
n=1; %one-level
%sX = size(X);

%check size! need extension or not!
s = size(X);
s = s(2);  %bug!
pow = 2^n;
if rem(s,pow)>0
    sOK = ceil(s/pow)*pow;
    msg = strvcat(...
            ['The level of decomposition ' int2str(n)],...
            ['and the length of the signal ' int2str(s)],...
            'are not compatible.',...
            ['Suggested length: ' int2str(sOK)],...
            '(see Signal Extension Tool)', ...
            ' ', ...
            '2^Level has to divide the length of the signal.' ...
            ); %#ok<VCAT>
    errargt(mfilename,msg,'msg');
    varargout = {[] };
    return
end

%amy change
% % Set DWT_Mode to 'per'.
old_modeDWT = dwtmode('status','nodisp');
modeDWT = 'per';
dwtmode(modeDWT,'nodisp');

% Compute stationary wavelet coefficients.
evenoddVal = 0;
evenLEN    = 1;

% swd = zeros(n,s);
% swa = zeros(n,s);


%for k = 1:n
 k=1;
    % Extension.Cicular Shift
    lf = length(Lo);
    %case 'per' % Periodized extension (2).
    if rem(lx,2) , X = [X , X(:,end,:)]; lx = lx + 1; end
        %I = [lx-lf+1:lx , 1:lx , 1:lf]; %original
        I = [lx-lf/2+1:lx , 1:lx , 1:lf/2]; %amy change
        if lx<lf
            I = mod(I,lx);
            I(I==0) = lx;
        end
        X = X(:,I,:);
    
    % Decomposition.
    %swd(k,:) = wkeep1(wconv1(X,Hi),s,lf+1);
    %swa(k,:) = wkeep1(wconv1(X,Lo),s,lf+1);
    
   % swd(k,:) = wkeep1(convn(X,Hi),s,lf+1); %%problem!!solve!!
   % swa(k,:) = wkeep1(convn(X,Lo),s,lf+1);
    swd = zeros(n,lx);
    swa = zeros(n,lx);

    swd = convn(X,Hi); %%problem!!find it!!
    swa = convn(X,Lo);
    clear X  %%amy add
    lf = length(Lo);
    %first = [lf+lf+(lf/2)+1,lf+(lf/2)+lf+1,lf+(lf/2)+lf+1];  %%ok!!
    %first = [3*(lf/2)-1,3*(lf/2)-1,3*(lf/2)-1];  %%ok!!
    %first = [4*(lf/2)-2,4*(lf/2)-2,4*(lf/2)-2];  %%amy change 2011.11.10
    first = [lf+1,lf+1,lf+1];  

    last = first+lx-1;
    swd = swd(:,first(2):1:last(2),:);  %%problem!!solve!!wkeep1
    swa = swa(:,first(2):1:last(2),:);
 
    % upsample filters.
    Lo = dyadup(Lo,evenoddVal,evenLEN);
    Hi = dyadup(Hi,evenoddVal,evenLEN);
 
    % New value of x.
    %X = swa(k,:); %bug fix!
    X = swa;
    %X (:,first(2):1:last(2),:)= swa;
%end
L=swa;
H=swd;
%dwtmode(old_modeDWT,'nodisp'); %amy change
%%%%%%%%%%%%%%%%%%
%clear X
 %switch dwtEXTM
%     case 'zpd'
%     otherwise
%         lenL = size(L,2);
%         first = lf; last = lenL-lf+1;
%         L = L(:,first:last,:); H = H(:,first:last,:);
%         lenL = size(L,2);
%         first = 1+floor((lenL-lc)/2);  last = first+lc-1;
%         L = L(:,first:last,:); H = H(:,first:last,:);
% end
% 
% L = L(:,2:2:end,:);
% H = H(:,2:2:end,:);
%%%% 
% if isequal(dwtEXTM,'per')
%     las = ceil(sX(2));
%     L = L(:,1:las,:);
%     H = H(:,1:las,:);
% end
% 
if ~isempty(perm)
    L = permute(L,perm);
    H = permute(H,perm);
end
%-----------------------------------------------------------------------%

