clc;clear;close all
%workshop: training data Training_IV__SNR=40__SIGNAL

%load one voxel

bval= dlmread( 'dsi.bval')';
bvec = dlmread('dsi.bvec')';

b_table = [bvec;bval];
voxel = MultiTensor()
voxel.M = 2;
voxel.f = [0.5,0.5];
voxel.lambda		= [.3 .3 1.7; .3 .3 1.7]' * 1e-3;
voxel.R(:,:,1)= voxel.ROTATION(   0, 0 );
voxel.R(:,:,2)= voxel.ROTATION(   pi/2, pi/2 );

% voxel.M = 1;
% voxel.f = [1.0];
% voxel.lambda		= [.3 .3 1.7]' * 1e-3;
% voxel.R(:,:,1)= voxel.ROTATION(   pi/4, pi/4 );



S = acquireWithScheme( voxel, b_table', 1.0/20 );


gridsize = 17;
grid_origin = floor(gridsize/2)+1;
bv =bval;
bsort = sort(bv);
bmin = bsort(2);
bv = floor(sqrt(bv / bmin));
qtable = [bv', bv', bv'] .* bvec';
q = floor(qtable+0.5);
% figure
% plot3(q(:,1),q(:,2),q(:,3),'r+')
% bvec(1,:) = bvec(1,:) .* sqrt(bval);
% bvec(2,:) = bvec(2,:) .* sqrt(bval);
% bvec(3,:) = bvec(3,:) .* sqrt(bval);
% figure
% plot3(bvec(1,:),bvec(2,:),bvec(3,:),'r+')

n=515;
r = sqrt(q(:,1).^2 + q(:,2).^2+q(:,3).^2);
hanning_filter = 0.5* cos(2.0*pi*r / 32);

% the signal S after hanning filter 
value=S.*hanning_filter; 

% to get the q space index
q=q+grid_origin;

% To value sq
sq=zeros(gridsize,gridsize,gridsize);
for i=1:n
    sq(q(i,1),q(i,2),q(i,3))=sq(q(i,1),q(i,2),q(i,3))+value(i);
end

%To calculate PDF of each voxel, filter 16x16x16 window
Pr=fftshift((real(fftn(ifftshift(sq),[gridsize,gridsize,gridsize]))));
Pr(Pr<0)= 0;
figure('name','BEFORE WT');
subplot(221)
imagesc(squeeze(sq(grid_origin,:,:)))
subplot(222)
imagesc(squeeze(sq(:,grid_origin,:)))
subplot(223)
imagesc(squeeze(sq(:,:,grid_origin)))

% load odf_faces, odf_vertices
load('odf6.mat')

odf_gt = voxel.ODF_true(odf_vertices(1,1:length(odf_vertices)/2)',odf_vertices(2,1:length(odf_vertices)/2)',odf_vertices(3,1:length(odf_vertices)/2)');
%%plot error
odf_points = odf_vertices.*repmat(odf_gt-min(odf_gt),[2 3])';
polygon.vertices = odf_points';
polygon.faces = odf_faces'+1;
polygon.facevertexcdata = abs(odf_vertices)';
figure('name','ODF_GT');
p = patch(polygon);
set(p,'FaceColor','flat','EdgeColor','none');
daspect([1 1 1])
view(3); axis tight
camlight
lighting gouraud




% To calculate the ODF of each voxel
odf=zeros(length(odf_vertices)/2,1);
r=2.1:0.2:6;
for m=1:length(odf_vertices)/2
   
   xi=grid_origin+r*odf_vertices(1,m);
   yi=grid_origin+r*odf_vertices(2,m);
   zi=grid_origin+r*odf_vertices(3,m);
   PrI=interp3(Pr,xi,yi,zi,'linear');   
   
   odf(m)=sum(PrI.*r.^2);

end

%%plot error
odf_points = odf_vertices.*repmat(odf-min(odf),[2 3])';
polygon.vertices = odf_points';
polygon.faces = odf_faces'+1;
polygon.facevertexcdata = abs(odf_vertices)';
figure('name','BEFORE WT');
p = patch(polygon);
set(p,'FaceColor','flat','EdgeColor','none');
daspect([1 1 1])
view(3); axis tight
camlight
lighting gouraud

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Example add function test DWT-3D/SWT-3D
%test DWT-3D
n = 3;  % level
dec_wave=wavedec3(sq,n,'bior3.5','per'); % daubechies db4 /db8/ bior3.5 wavelet

for i = 1:size(dec_wave.dec,1)
    sigma=std(dec_wave.dec{i}(:));
    T{i} = 10*(sigma)*sqrt(2*log(length (dec_wave.dec{i}(:)))/length (dec_wave.dec{i}(:))); %Donoho,1995
    %T{i} = 1*(sigma)*0.05; % keep 5% of threshold. 20110728 amy
    %T{i} = 1*(sigma)*0.1; % keep 10% of threshold. 20110728 amy
    dec_wave.dec{i} = dec_wave.dec{i} .* (abs(dec_wave.dec{i}) > T{i});
end

sq = waverec3(dec_wave);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%To calculate PDF of each voxel, filter 16x16x16 window
Pr=fftshift((real(fftn(ifftshift(sq),[gridsize,gridsize,gridsize]))));
Pr(Pr<0)= 0;


figure('name','AFTER WT');
subplot(221)
imagesc(squeeze(sq(grid_origin,:,:)))
subplot(222)
imagesc(squeeze(sq(:,grid_origin,:)))
subplot(223)
imagesc(squeeze(sq(:,:,grid_origin)))


% To calculate the ODF of each voxel
odf=zeros(length(odf_vertices)/2,1);
r=2.1:0.2:6;
for m=1:length(odf_vertices)/2
   
   xi=grid_origin+r*odf_vertices(1,m);
   yi=grid_origin+r*odf_vertices(2,m);
   zi=grid_origin+r*odf_vertices(3,m);
   PrI=interp3(Pr,xi,yi,zi,'linear');   
   
   odf(m)=sum(PrI.*r.^2);

end

%%plot error
odf_points = odf_vertices.*repmat(odf-min(odf),[2 3])';
polygon.vertices = odf_points';
polygon.faces = odf_faces'+1;
polygon.facevertexcdata = abs(odf_vertices)';
figure('name','AFTER WT');
p = patch(polygon);
set(p,'FaceColor','flat','EdgeColor','none');
daspect([1 1 1])
view(3); axis tight
camlight
lighting gouraud
%%%fiber orientation
indexp = find_peak(odf,odf_faces);
index0=odf_vertices(:,indexp);
